#include <windows.h>
#include <stdio.h>
#include <direct.h>
#include <string.h>
#include <math.h>

typedef struct {
        _int64  filecount;
        _int64  filesize;
        _int64  filerealsize;
        _int64  filedisksize;
        _int64  usedclusters;
}DirrInfo;

void FrmtDouble(double val, int prec, char *buffer)
{
        int     i,groups[15];
        double  val1;
        int     rest;
        char    tmpbuff[15];
        char    tmpfrmt[15];
        BOOL    first=TRUE;

        if (val>0) val1=floor(val);
              else val1=fabs(ceil(val));

        rest=(int)(floor( (fabs(val)-fabs(val1)) * pow((double)10,(double)prec+1) ));
        if (rest%10>=5) rest=rest/10+1;
                   else rest=rest/10;

        for (i=0;(i<15)&&(val1!=0);i++)
        {
                groups[i]=(int)(val1-floor(val1/(double)1000)*(double)1000);
                val1=floor(val1/1000);
        }
        strcpy (buffer,"");
        if (val<0) strcat (buffer,"-");
        if (i==0) strcpy (buffer,"0");
        i--;
        while (i>=0)
        {
                if (first)
                {
                        sprintf (tmpbuff,"%i",groups[i]);
                        first=FALSE;
                }
                else sprintf (tmpbuff,",%03i",groups[i]);
                strcat(buffer,tmpbuff);
                i--;
        }
        if (prec)
        {
                strcat(buffer,".");
                sprintf (tmpfrmt,"%%0%ii",prec);
                sprintf (tmpbuff,tmpfrmt,rest);
                strcat(buffer,tmpbuff);
        }
}

void Dirr (char *path, DirrInfo *di, int clustersize)
{
        char            mask[MAX_PATH],tmp[MAX_PATH];
        HANDLE          find_handle;
        _int64          s,s1;
        WIN32_FIND_DATA ff;

        strcpy (mask,path);
        strcat (mask,"*.*");

        find_handle=FindFirstFile(mask,&ff);
        if (find_handle==INVALID_HANDLE_VALUE) return;
        while (1)
        {
                if (ff.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
                {
                        if (*ff.cFileName!='.')
                        {
                                strcpy(tmp,path);
                                strcat(tmp,ff.cFileName);
                                strcat(tmp,"\\");
                                Dirr(tmp,di,clustersize);
                        }
                }
                else
                {
                        strcpy(tmp,path);
                        strcat(tmp,ff.cFileName);
                        if (strlen(tmp)>75) tmp[75]=0;
                        printf ("%75c\r%s\r",' ',tmp);

                        di->filecount++;
                        di->filesize+=(((_int64)ff.nFileSizeHigh)<<32)+ff.nFileSizeLow;
                        if (ff.dwFileAttributes&FILE_ATTRIBUTE_COMPRESSED)
                        {
                                strcpy(tmp,path);
                                strcat(tmp,ff.cFileName);
                                s=GetCompressedFileSize(tmp,NULL);
                        }
                        else s=(((_int64)ff.nFileSizeHigh)<<32)+ff.nFileSizeLow;
                        di->filerealsize+=s;
                        s1=s/clustersize;
                        if (s%clustersize) s1++;
                        di->filedisksize+=s1*clustersize;
                        di->usedclusters+=s1;
                }
                if (!FindNextFile(find_handle,&ff)) break;
        }
        FindClose(find_handle);
}

void main(int argc, char *argv[])
{
        char     workpath[MAX_PATH];
        char     cdir[MAX_PATH];
        DirrInfo di={0,0,0,0,0};
        int      spc,bps,fc,tc;
        char     sz_filecount[19],sz_filesize[19],sz_filerealsize[19],sz_filedisksize[19];

        printf ("Disk Usage Statistic\nFreeware by Nick E. Geht, 1997\n");

        SetFileApisToOEM();

        _getcwd(cdir,MAX_PATH);
        if (argc>1)
        {
                _chdir(argv[1]);
        }
        _getcwd(workpath,MAX_PATH);
        strcat(workpath,"\\");

        CharUpper(workpath);
        printf ("Scan:<%s>\n",workpath);

        GetDiskFreeSpace(NULL,&spc,&bps,&fc,&tc);
        printf ("Bytes Per Cluster:%i\n",spc*bps);

        Dirr(workpath,&di,spc*bps);

        FrmtDouble((double)di.filecount   ,0,sz_filecount   );
        FrmtDouble((double)di.filesize    ,0,sz_filesize    );
        FrmtDouble((double)di.filerealsize,0,sz_filerealsize);
        FrmtDouble((double)di.filedisksize,0,sz_filedisksize);

        printf ("File Numbr|Total File Size| Real File Size|Real Disk using|Storage Ratio\n");
        printf ("%10s|%15s|%15s|%15s|%12.2f%%\n",sz_filecount
                                       ,sz_filesize
                                       ,sz_filerealsize
                                       ,sz_filedisksize
                                       ,(double)di.filedisksize*100/(double)di.filesize);
        _chdir(cdir);
}












